Multi-threaded Hello World

Implement a simple Hello World program that prints out lines of “Hello World!” all the time. Do that using two threads with one thread printing “Hello ” and the other one printing “World!”.
The output always has to be “Hello World!” with the two threads synchronizing their outputs.
Since busy waiting is evil it is not a valid solution :-). Synchronize the threads using your favorite synchronization paradigm. Also try synchronizing the threads using message passing (see next task and http://en.wikipedia.org/wiki/Message_passing). Use either C/C++ (POSIX, Win32, WinRT) or Java APIs to implement the program.

== DEPENDENCIES
    - libcunit1-dev for tests

== COMPILE
    - Run: make all

== RUNNING
    -  ./helloworld: Will print "Hello World!" in an infinite loop

    -  ./test_helloworld: Will print "Hello World!" to a file (stdout.txt)
       by redirecting the stdout and assert each line of the file to be "Hello World!"
       using the CUnit framework
